#include "adc.h"
#include "main.h"

/*
This is the ADC0 C file which contains functions 
to initialize and get ADC0 Data from MCU

I used my ADC Config Utility to create this file.
*/
void InitADC(void)
{
    PINSEL1 |= 0x300000;            // Set the PIN P0.26 as ADC0.7
    IO0DIR &= ~(0x6000000);     // Ensure the pin is Input
    AD0CR = 0;                               // Clear the ADC Control Register
    AD0CR = 0x200C80;               // SEL = 7, CLKDIV = 12, ADC is ON
}
int GetADC(void)
{
    int temp = 0;                           // Temp result holder
    AD0CR |= 0x1000000;         // Start Conversion
    while(!(AD0GDR&0x80000000));       // While Done Bit is not set loop, When set continue
    temp = ((AD0GDR >> 6) & 0x03FF);    // Get Result and AND it with max value 0x3ff to ensure no extra bits
    return temp;        // Return our data
}