
#include "main.h"

BYTE FILEs[8][20];
UINT FILEc;

UINT File_Count;
UINT Page_Count;
UINT Sel_File;
UINT Sel_Page;
UINT Files_In_Page;
UINT Listing;
BYTE IsViewing;

//Program Definitions
#define UP 1
#define DOWN 2
#define ENTER 3
#define NONE 4

BYTE OldIndex = 0xff;
BYTE MyIndex = 0;
BYTE myStr[20];
//Program Functions and stuff
    FATFS fs;          // Work area (file system object) for the volume
//Program Start
int main(void)
{
    BYTE isMounted=0;
    UINT NavResult = 0;
    BYTE ASK=0;
    UINT br;           // File read count
    FRESULT res;       // Petit FatFs function common result code
    UINT temp;

    ctl_global_interrupts_disable();

    PINSEL0 = 0x00000000;    //All GPIO
    PINSEL1 = 0x00000000;    //All GPIO
    IO0DIR = 0xFFFFFFFF;        //0xF9FFFFFF;         //All Output
    IO0CLR = 0xFFFFFFFF;        //All Low

    InitTimer1();
    LCD_init();
    InitADC();
    LCD_clear(WHITE);
    Delay_MS(300);
    //LCD_color_H();
    
    DrawBox(10,10,40,40,RED);
    Delay_MS(2000);
    LCD_ShowString(0,0,WHITE,BLACK,"Jason");
    while(1);
    LCD_clear(BLACK);

    while(1) {
        switch(isMounted)
        {
            case 0:
                if(SD_CD==0)
                {
                    isMounted = 1;
                    ASK =1;
                }
                else
                {
                    if(!ASK)
                    {
                        ASK =1;
                        LCD_ShowString(2,2,WHITE,BLACK,"Insert SD...");
                    }
                }
                break;
            case 1:
                if(SD_CD==0)
                {
                        Sel_Page = 0;
                        Sel_File = 0;
                        Page_Count = 0;
                        File_Count =0;
                        res = MountSD();
                        if(res)
                        {
                            isMounted = 0;
                        }
                        else
                        {
                            isMounted = 2;
                            Delay_MS(300);
                            res = pf_open("LOGO.BMP\0");
                            draw_bitmap("LOGO.BMP\0");
                            NavResult = 0;
                            Delay_MS(2000);
                            LCD_clear(WHITE);
                            ListPage();
                        }
                }
                break;

            case 2:
                if(SD_CD==1)
                {
                    ASK =0;
                    isMounted = 0;
                }
                break;
        }
        if(isMounted == 2)
        {
            NavResult = GetButton();

            if(NavResult == UP)
            {   
                    if(Sel_Page > 0)
                    {
                        if(MyIndex == 0)
                        {
                            Sel_Page--;
                            res = scan_files("/");
                            if(IsViewing==0)
                            {
                                ListPage();
                            }
                            else
                            {
                                res = pf_open(FILEs[MyIndex]);
                                draw_bitmap(FILEs[MyIndex]);
                            }
                        }
                        else
                        {
                            if(MyIndex != 0)
                                MyIndex--;

                            if(IsViewing==1)
                            {
                                res = pf_open(FILEs[MyIndex]);
                                draw_bitmap(FILEs[MyIndex]);
                            }
                        } 
                    }
                    else
                    {
                        if(MyIndex != 0)
                            MyIndex--;
                        if(IsViewing==1)
                        {
                            res = pf_open(FILEs[MyIndex]);
                            draw_bitmap(FILEs[MyIndex]);
                        }
                    } 
            }
            if(NavResult == ENTER)
            {   
                if(IsViewing == 1)
                {
                    while((GetButton()) != ENTER);
                    Delay_MS(300);
                    ListPage();                
                    IsViewing = 0;
                }
                else
                {
                    IsViewing = 1;
                    res = pf_open(FILEs[MyIndex]);
                    if(!res)
                    {
                        draw_bitmap(FILEs[MyIndex]);
                        NavResult = 0;
                        Delay_MS(300);
                    }
                }
            }
            if(NavResult == DOWN)
            {   
                MyIndex++;
                if(MyIndex > (Files_In_Page-1))
                {
                    if(Page_Count > 0)
                    {
                        if(Sel_Page < Page_Count)
                        {
                            Sel_Page++;
                            res = scan_files("/");
                            MyIndex = 0;
                            if(IsViewing==0)
                            {
                                ListPage();
                            }
                          
                        }
                        else
                        {
                            MyIndex =MyIndex-1;
                            if(IsViewing==1)
                            {
                                res = pf_open(FILEs[MyIndex]);
                                draw_bitmap(FILEs[MyIndex]);
                            }        
                        }
                    } 
                    else
                    {
                        MyIndex =MyIndex-1;
                    }
                }
            if(IsViewing==1)
            {
                res = pf_open(FILEs[MyIndex]);
                draw_bitmap(FILEs[MyIndex]);
            }
            }

            if(OldIndex != MyIndex)
            {
                OldIndex = MyIndex;
                for(temp=0;temp<Files_In_Page;temp++)
                {
                    if(IsViewing==1) break;
                    if(MyIndex == temp)
                        LCD_ShowString(2,22+(temp*16),RED,WHITE,">");
                    else
                        LCD_ShowString(2,22+(temp*16),BLACK,WHITE," ");
                }
            }

        }
        Delay_MS(300);
    }
  return 0;
}
BYTE GetButton(void)
{
    UINT ADC_Res=0;
    ADC_Res = GetADC();

    if((ADC_Res > 0xE0) && (ADC_Res < 0xF0))
        return DOWN;
    if((ADC_Res > 0x1C0) && (ADC_Res < 0x1D0))
        return ENTER;
    if((ADC_Res > 0x2C0) && (ADC_Res < 0x2D0))
        return UP;

    return NONE;
}
void ListPage(void)
{
    UINT temp;
    LCD_clear(WHITE);
    DrawFill(0,0,127,17,BLUE);
    DrawBox(0,0,127,17,BLACK);
    sprintf(myStr,"Root:     %i / %i",(Sel_Page+1),(Page_Count+1));
    LCD_ShowString(2,2,WHITE,BLUE,myStr);
    for(temp = 0; temp < Files_In_Page; temp++)
    {
        sprintf(myStr," %i.%s",(temp+1),FILEs[temp]);
        LCD_ShowString(2,22+(temp*16),BLACK,WHITE,myStr);
    }
    OldIndex=0xff;
}

FRESULT MountSD(void)
{
    FRESULT res;
    FRESULT resMount;

    Delay_MS(200);

    resMount = pf_mount(&fs);
    Listing = 0;
    if (resMount) 
    {
        LCD_ShowString(2,2,WHITE,BLACK,"Reading...");
        MountSD();
    }
    else
    {
        res = scan_files("/");
    }
    return res;
}
void InitTimer1(void)
{
    /* Initialize Timer 1 */
    T1TCR=0x0;
    T1TC=0x0;
    T1PR=0x0;
    T1PC=0x0;
    /* Set the match value in the match register */
    T1MR0=5000000;
    /* Reset and interrupt on match */
    T1MCR=0x3;
    /* Initialize VIC */
    VICIntSelect=0x20; /* Timer 1 selected as FIQ */
    VICIntEnable= 0x20; /*Timer 1 interrupt enabled*/
}

//Delay Functions
void Delay_MS(int time)
{
    T1MR0=50000;
    T1TC = 0;
    while(time--)
    {
        T1TCR=0x1;
        while(!Timer1);
        T1IR |= 0x01;
    } 
}

void Delay_US(int time)
{
    T1MR0=50;
    T1TC = 0;
    while(time--)
    {
        T1TCR=0x1;
        while(!Timer1);
        T1IR |= 0x01;
    } 
}